git-mergetool: check return value from read
[git/git.git] / git-mergetool.sh
CommitLineData
c4b4a5af
TT
1#!/bin/sh
2#
3# This program resolves merge conflicts in git
4#
5# Copyright (c) 2006 Theodore Y. Ts'o
6#
7# This file is licensed under the GPL v2, or a later version
2571ac67 8# at the discretion of Junio C Hamano.
c4b4a5af
TT
9#
10
682b451f 11USAGE='[--tool=tool] [-y|--no-prompt|--prompt] [file to merge] ...'
c4b4a5af 12SUBDIRECTORY_OK=Yes
8f321a39 13OPTIONS_SPEC=
21d0ba7e 14TOOL_MODE=merge
c4b4a5af 15. git-sh-setup
21d0ba7e 16. git-mergetool--lib
c4b4a5af
TT
17require_work_tree
18
19# Returns true if the mode reflects a symlink
262c981e 20is_symlink () {
c4b4a5af
TT
21 test "$1" = 120000
22}
23
ff7f089e
JM
24is_submodule () {
25 test "$1" = 160000
26}
27
262c981e 28local_present () {
c4b4a5af
TT
29 test -n "$local_mode"
30}
31
262c981e 32remote_present () {
c4b4a5af
TT
33 test -n "$remote_mode"
34}
35
262c981e 36base_present () {
c4b4a5af
TT
37 test -n "$base_mode"
38}
39
40cleanup_temp_files () {
41 if test "$1" = --save-backup ; then
ff7f089e
JM
42 rm -rf -- "$MERGED.orig"
43 test -e "$BACKUP" && mv -- "$BACKUP" "$MERGED.orig"
c4b4a5af
TT
44 rm -f -- "$LOCAL" "$REMOTE" "$BASE"
45 else
46 rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
47 fi
48}
49
262c981e 50describe_file () {
c4b4a5af
TT
51 mode="$1"
52 branch="$2"
53 file="$3"
54
27090aa1 55 printf " {%s}: " "$branch"
c4b4a5af 56 if test -z "$mode"; then
27090aa1 57 echo "deleted"
c4b4a5af 58 elif is_symlink "$mode" ; then
27090aa1 59 echo "a symbolic link -> '$(cat "$file")'"
ff7f089e
JM
60 elif is_submodule "$mode" ; then
61 echo "submodule commit $file"
c4b4a5af
TT
62 else
63 if base_present; then
ff7f089e 64 echo "modified file"
c4b4a5af 65 else
ff7f089e 66 echo "created file"
c4b4a5af
TT
67 fi
68 fi
c4b4a5af
TT
69}
70
71
72resolve_symlink_merge () {
d1dc6959 73 while true; do
27090aa1 74 printf "Use (l)ocal or (r)emote, or (a)bort? "
e622f41d 75 read ans || return 1
c4b4a5af
TT
76 case "$ans" in
77 [lL]*)
b3ea27e4
CB
78 git checkout-index -f --stage=2 -- "$MERGED"
79 git add -- "$MERGED"
c4b4a5af 80 cleanup_temp_files --save-backup
b0169d84 81 return 0
c4b4a5af 82 ;;
5a174f1a 83 [rR]*)
b3ea27e4
CB
84 git checkout-index -f --stage=3 -- "$MERGED"
85 git add -- "$MERGED"
c4b4a5af 86 cleanup_temp_files --save-backup
b0169d84 87 return 0
c4b4a5af 88 ;;
5a174f1a 89 [aA]*)
b0169d84 90 return 1
c4b4a5af
TT
91 ;;
92 esac
93 done
94}
95
96resolve_deleted_merge () {
d1dc6959 97 while true; do
27090aa1
TT
98 if base_present; then
99 printf "Use (m)odified or (d)eleted file, or (a)bort? "
100 else
101 printf "Use (c)reated or (d)eleted file, or (a)bort? "
102 fi
6b445773 103 read ans || return 1
c4b4a5af 104 case "$ans" in
27090aa1 105 [mMcC]*)
b3ea27e4 106 git add -- "$MERGED"
c4b4a5af 107 cleanup_temp_files --save-backup
b0169d84 108 return 0
c4b4a5af 109 ;;
5a174f1a 110 [dD]*)
b3ea27e4 111 git rm -- "$MERGED" > /dev/null
c4b4a5af 112 cleanup_temp_files
b0169d84 113 return 0
c4b4a5af 114 ;;
5a174f1a 115 [aA]*)
b0169d84 116 return 1
c4b4a5af
TT
117 ;;
118 esac
119 done
120}
121
ff7f089e
JM
122resolve_submodule_merge () {
123 while true; do
124 printf "Use (l)ocal or (r)emote, or (a)bort? "
6b445773 125 read ans || return 1
ff7f089e
JM
126 case "$ans" in
127 [lL]*)
128 if ! local_present; then
129 if test -n "$(git ls-tree HEAD -- "$MERGED")"; then
130 # Local isn't present, but it's a subdirectory
131 git ls-tree --full-name -r HEAD -- "$MERGED" | git update-index --index-info || exit $?
132 else
133 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
134 git update-index --force-remove "$MERGED"
135 cleanup_temp_files --save-backup
136 fi
137 elif is_submodule "$local_mode"; then
138 stage_submodule "$MERGED" "$local_sha1"
139 else
140 git checkout-index -f --stage=2 -- "$MERGED"
141 git add -- "$MERGED"
142 fi
143 return 0
144 ;;
145 [rR]*)
146 if ! remote_present; then
147 if test -n "$(git ls-tree MERGE_HEAD -- "$MERGED")"; then
148 # Remote isn't present, but it's a subdirectory
149 git ls-tree --full-name -r MERGE_HEAD -- "$MERGED" | git update-index --index-info || exit $?
150 else
151 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
152 git update-index --force-remove "$MERGED"
153 fi
154 elif is_submodule "$remote_mode"; then
155 ! is_submodule "$local_mode" && test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
156 stage_submodule "$MERGED" "$remote_sha1"
157 else
158 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
159 git checkout-index -f --stage=3 -- "$MERGED"
160 git add -- "$MERGED"
161 fi
162 cleanup_temp_files --save-backup
163 return 0
164 ;;
165 [aA]*)
166 return 1
167 ;;
168 esac
169 done
170}
171
172stage_submodule () {
173 path="$1"
174 submodule_sha1="$2"
175 mkdir -p "$path" || die "fatal: unable to create directory for module at $path"
176 # Find $path relative to work tree
177 work_tree_root=$(cd_to_toplevel && pwd)
178 work_rel_path=$(cd "$path" && GIT_WORK_TREE="${work_tree_root}" git rev-parse --show-prefix)
179 test -n "$work_rel_path" || die "fatal: unable to get path of module $path relative to work tree"
180 git update-index --add --replace --cacheinfo 160000 "$submodule_sha1" "${work_rel_path%/}" || die
181}
182
0ec7b6c2
CB
183checkout_staged_file () {
184 tmpfile=$(expr "$(git checkout-index --temp --stage="$1" "$2")" : '\([^ ]*\) ')
185
186 if test $? -eq 0 -a -n "$tmpfile" ; then
ff4a1855 187 mv -- "$(git rev-parse --show-cdup)$tmpfile" "$3"
0ec7b6c2
CB
188 fi
189}
190
c4b4a5af 191merge_file () {
b3ea27e4 192 MERGED="$1"
c4b4a5af 193
9a62d72d 194 f=$(git ls-files -u -- "$MERGED")
c4b4a5af 195 if test -z "$f" ; then
b3ea27e4
CB
196 if test ! -f "$MERGED" ; then
197 echo "$MERGED: file not found"
ce5b6d75 198 else
b3ea27e4 199 echo "$MERGED: file does not need merging"
ce5b6d75 200 fi
b0169d84 201 return 1
c4b4a5af
TT
202 fi
203
b3ea27e4 204 ext="$$$(expr "$MERGED" : '.*\(\.[^/]*\)$')"
641dba49
PH
205 BACKUP="./$MERGED.BACKUP.$ext"
206 LOCAL="./$MERGED.LOCAL.$ext"
207 REMOTE="./$MERGED.REMOTE.$ext"
208 BASE="./$MERGED.BASE.$ext"
c4b4a5af 209
9a62d72d
DA
210 base_mode=$(git ls-files -u -- "$MERGED" | awk '{if ($3==1) print $1;}')
211 local_mode=$(git ls-files -u -- "$MERGED" | awk '{if ($3==2) print $1;}')
212 remote_mode=$(git ls-files -u -- "$MERGED" | awk '{if ($3==3) print $1;}')
c4b4a5af 213
ff7f089e
JM
214 if is_submodule "$local_mode" || is_submodule "$remote_mode"; then
215 echo "Submodule merge conflict for '$MERGED':"
216 local_sha1=$(git ls-files -u -- "$MERGED" | awk '{if ($3==2) print $2;}')
217 remote_sha1=$(git ls-files -u -- "$MERGED" | awk '{if ($3==3) print $2;}')
218 describe_file "$local_mode" "local" "$local_sha1"
219 describe_file "$remote_mode" "remote" "$remote_sha1"
220 resolve_submodule_merge
221 return
222 fi
223
224 mv -- "$MERGED" "$BACKUP"
225 cp -- "$BACKUP" "$MERGED"
226
ff4a1855
CB
227 base_present && checkout_staged_file 1 "$MERGED" "$BASE"
228 local_present && checkout_staged_file 2 "$MERGED" "$LOCAL"
229 remote_present && checkout_staged_file 3 "$MERGED" "$REMOTE"
c4b4a5af
TT
230
231 if test -z "$local_mode" -o -z "$remote_mode"; then
b3ea27e4 232 echo "Deleted merge conflict for '$MERGED':"
c4b4a5af
TT
233 describe_file "$local_mode" "local" "$LOCAL"
234 describe_file "$remote_mode" "remote" "$REMOTE"
235 resolve_deleted_merge
236 return
237 fi
238
239 if is_symlink "$local_mode" || is_symlink "$remote_mode"; then
b3ea27e4 240 echo "Symbolic link merge conflict for '$MERGED':"
c4b4a5af
TT
241 describe_file "$local_mode" "local" "$LOCAL"
242 describe_file "$remote_mode" "remote" "$REMOTE"
243 resolve_symlink_merge
244 return
245 fi
246
b3ea27e4 247 echo "Normal merge conflict for '$MERGED':"
c4b4a5af
TT
248 describe_file "$local_mode" "local" "$LOCAL"
249 describe_file "$remote_mode" "remote" "$REMOTE"
682b451f
CB
250 if "$prompt" = true; then
251 printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
6b445773 252 read ans || return 1
682b451f 253 fi
c4b4a5af 254
47d65924
DA
255 if base_present; then
256 present=true
257 else
258 present=false
259 fi
21d0ba7e
DA
260
261 if ! run_merge_tool "$merge_tool" "$present"; then
b3ea27e4
CB
262 echo "merge of $MERGED failed" 1>&2
263 mv -- "$BACKUP" "$MERGED"
162eba8b
CB
264
265 if test "$merge_keep_temporaries" = "false"; then
266 cleanup_temp_files
267 fi
268
b0169d84 269 return 1
c4b4a5af 270 fi
44c36d1c
CB
271
272 if test "$merge_keep_backup" = "true"; then
b3ea27e4 273 mv -- "$BACKUP" "$MERGED.orig"
44c36d1c
CB
274 else
275 rm -- "$BACKUP"
276 fi
277
b3ea27e4 278 git add -- "$MERGED"
c4b4a5af 279 cleanup_temp_files
b0169d84 280 return 0
c4b4a5af
TT
281}
282
682b451f
CB
283prompt=$(git config --bool mergetool.prompt || echo true)
284
822f7c73 285while test $# != 0
c4b4a5af
TT
286do
287 case "$1" in
288 -t|--tool*)
289 case "$#,$1" in
290 *,*=*)
9a62d72d 291 merge_tool=$(expr "z$1" : 'z-[^=]*=\(.*\)')
c4b4a5af
TT
292 ;;
293 1,*)
294 usage ;;
295 *)
296 merge_tool="$2"
297 shift ;;
298 esac
299 ;;
682b451f
CB
300 -y|--no-prompt)
301 prompt=false
302 ;;
303 --prompt)
304 prompt=true
305 ;;
c4b4a5af 306 --)
ce2c3ebb 307 shift
c4b4a5af
TT
308 break
309 ;;
310 -*)
311 usage
312 ;;
313 *)
314 break
315 ;;
316 esac
317 shift
318done
319
b0169d84
CB
320prompt_after_failed_merge() {
321 while true; do
322 printf "Continue merging other unresolved paths (y/n) ? "
6b445773 323 read ans || return 1
b0169d84
CB
324 case "$ans" in
325
326 [yY]*)
327 return 0
328 ;;
329
330 [nN]*)
331 return 1
332 ;;
333 esac
334 done
335}
e3fa2c76 336
47d65924
DA
337if test -z "$merge_tool"; then
338 merge_tool=$(get_merge_tool "$merge_tool") || exit
339fi
70af4e9b 340merge_keep_backup="$(git config --bool mergetool.keepBackup || echo true)"
21d0ba7e 341merge_keep_temporaries="$(git config --bool mergetool.keepTemporaries || echo false)"
c4b4a5af 342
b0169d84
CB
343last_status=0
344rollup_status=0
bb0a484e
DA
345rerere=false
346
347files_to_merge() {
348 if test "$rerere" = true
349 then
2f59c947 350 git rerere remaining
bb0a484e
DA
351 else
352 git ls-files -u | sed -e 's/^[^ ]* //' | sort -u
353 fi
354}
355
c4b4a5af
TT
356
357if test $# -eq 0 ; then
bb0a484e
DA
358 cd_to_toplevel
359
360 if test -e "$GIT_DIR/MERGE_RR"
361 then
362 rerere=true
363 fi
364
365 files=$(files_to_merge)
0eea3451
CB
366 if test -z "$files" ; then
367 echo "No files need merging"
368 exit 0
369 fi
af314714
CB
370
371 # Save original stdin
372 exec 3<&0
373
bb0a484e
DA
374 printf "Merging:\n"
375 printf "$files\n"
376
377 files_to_merge |
0eea3451
CB
378 while IFS= read i
379 do
b0169d84 380 if test $last_status -ne 0; then
af314714 381 prompt_after_failed_merge <&3 || exit 1
c4b4a5af 382 fi
0eea3451 383 printf "\n"
af314714 384 merge_file "$i" <&3
b0169d84
CB
385 last_status=$?
386 if test $last_status -ne 0; then
387 rollup_status=1
388 fi
0eea3451 389 done
c4b4a5af 390else
0eea3451 391 while test $# -gt 0; do
b0169d84
CB
392 if test $last_status -ne 0; then
393 prompt_after_failed_merge || exit 1
394 fi
0eea3451
CB
395 printf "\n"
396 merge_file "$1"
b0169d84
CB
397 last_status=$?
398 if test $last_status -ne 0; then
399 rollup_status=1
400 fi
0eea3451
CB
401 shift
402 done
c4b4a5af 403fi
b0169d84
CB
404
405exit $rollup_status